#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define pb push_back
typedef long long ll;

const int nmax=200010;

tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ost;

int mas[nmax]={0},used[nmax]={0};
int dp[nmax][2]={0};
vector<int> graf[nmax],topsort,temp;

void dfs(int v) {
    used[v]=1;
    for(int i:graf[v]) {
        if(used[i]) {
            continue;
        }
        dfs(i);
    }
    topsort.pb(v);
    return ;
}

bool check(int lst,int n) {
    temp.clear();
    for(int i=0;i<n;i++) {
        if(topsort[i]==lst) {
            continue;
        }
        temp.pb(topsort[i]);
    }
    temp.pb(lst);
    bool flag=0;
    for(int i:graf[temp[n-1]]) {
        if(i==1) {
            flag=1;
        }
    }
    if(!flag) {
        return 0;
    }
    for(int i=0;i<n-1;i++) {
        flag=0;
        for(int j:graf[temp[i]]) {
            if(j==temp[i+1]) {
                flag=1;
            }
        }
        if(!flag) {
            return 0;
        }
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n,m,u,v;
    cin >> n >> m;
    for(int i=0;i<m;i++) {
        cin >> u >> v;
        graf[u].pb(v);
    }
    dfs(1);
    reverse(topsort.begin(),topsort.end());
    if(topsort.size()!=n) {
        cout << "NO\n";
        return 0;
    }
    bool flag=0;
    for(int i=2;i<=n;i++) {
        for(int j:graf[i]) {
            if(j==1) {
                flag=check(i,n);
                if(flag) {
                    cout << "YES\n";
                    for(int k=0;k<n;k++) {
                        cout << temp[k] << " ";
                    }
                    cout << "1\n";
                    return 0;
                }
                break;
            }
        }
    }
    cout << "NO\n";
    assert(0);
    return 0;
}
